/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: triangle_free.cc 9298 2009-09-02 23:10:56Z gawrilow $
*/

#include <polymake.h>
#include <Graph.h>
#include <IncidenceMatrix.h>

namespace polymake { namespace graph {

   template <typename Graph>
   bool triangle_free(const GenericGraph<Graph,Undirected>& G)
   {
      const int n=G.nodes();
      const IncidenceMatrix<> Adj=convolute(convolute(adjacency_matrix(G), T(adjacency_matrix(G))),
					    T(adjacency_matrix(G)));

      // true iff there is no (directed) circle of length 3
      for (int i=0; i<n; ++i)
	 if (Adj(i,i)) return false;

      return true;
   }

   FunctionTemplate4perl("triangle_free(props::Graph<Undirected>)");
} }
